<?php
namespace EMS\PortalFuncionario\Geral\Services;

use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Repository\SolicitacaoRepository;
use EMS\PortalFuncionario\Util\DateUtil;
use Ems\PortalFuncionario\Util\HcmServices;

class SolicitacaoService{
    /** @var EntityManager */
    protected $entityManager;

    /** @var SolicitacaoRepository */
    protected $solicitacaoRepository;

    /** @var HcmServices */
    protected $hcmServices;

	public function __construct(
        EntityManager           $entityManager,
        SolicitacaoRepository   $solicitacaoRepository,
        HcmServices             $hcmServices
    ) {
		$this->entityManager            = $entityManager;
		$this->solicitacaoRepository    = $solicitacaoRepository;
        $this->hcmServices              = $hcmServices;
    }

    public function getSolicitacao(
        string $nrvinculom,
        string $nrorg,
        string $cdoperador
    ) : array {
        try {
            return $this->solicitacaoRepository->getSolicitacao(
                $nrvinculom,
                $nrorg,
                $cdoperador
            );
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getItemSolicitacao(
        int $nrOrg,
        int $nrSolicitacao
    ) {
        $route = 'getItemSolicitacao';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRSOLICITACAO' => $nrSolicitacao,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);

        return $result['dataset'][$route];
    }
}
